Integration with React
It's helpful to know the basics of React before jumping into this guide. If a refresher is needed, the React documentation covers all the essentials.
DHTMLX Kanban works well with React. There are some ready-to-use code examples showing how to set up DHTMLX Kanban in a React environment. For more details, check out this Example on GitHub.
Creating a project
A basic React project can be created, or you can use React with Vite. The example project here is called my-react-kanban-app:
npx create-react-app my-react-kanban-app
Installation of dependencies
Move into the new app folder:
cd my-react-kanban-app
Next, install the dependencies and start the development server. Just pick your package manager:
- For yarn:
yarn
yarn start
- For npm:
npm install
npm run dev
The app will start on localhost, usually at something like http://localhost:3000.
Creating Kanban
To get started with DHTMLX Kanban, grab the source code. It's best to stop the app first, then install the Kanban package.
Step 1. Package installation
Download the trial Kanban package and follow the README instructions. The trial version is available for 30 days.
Step 2. Component creation
A React component is needed to add Kanban to the app. Create a new file named Kanban.jsx in the src/ directory.
Importing source files
Open Kanban.jsx and import the Kanban files. There are a couple of options depending on the version:
- For the PRO version installed from a local folder, the imports look like this:
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
Depending on the package, you might need to import kanban.min.css if the files are minified.
- For the trial version, use these paths:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";
This guide shows how to set up the trial version.
Setting containers and adding Kanban with Toolbar
To show Kanban with a Toolbar, create containers for both and initialize them using their constructors:
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // include Kanban styles
export default function KanbanComponent(props) {
let toolbar_container = useRef(); // initialize container for Toolbar
let kanban_container = useRef(); // initialize container for Kanban
useEffect(() => {
// initialize the Kanban component
const kanban = new Kanban(kanban_container.current, {});
// initialize the Toolbar component
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // provide Kanban inner API
// other configuration properties
});
return () => {
kanban.destructor(); // destruct Kanban
toolbar.destructor(); // destruct Toolbar
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}
Adding styles
To make sure Kanban displays correctly, add some necessary styles for Kanban and its container in the main CSS file:
/* specify styles for initial page */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}
/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}
/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}
Loading data
Kanban needs some data to work with. Make a data.js file in the src/ directory and add some sample data:
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];
const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];
const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];
return { columns, cards, rows };
}
Next, open App.js and import the data. Then, pass the data into the <Kanban/> component as props:
import Kanban from "./Kanban";
import { getData } from "./data";
function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}
export default App;
Head over to Kanban.jsx and use the passed props in the Kanban configuration:
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // apply column data
cards: props.cards, // apply card data
rows: props.rows, // apply row data
rowKey: "type",
// other configuration properties
});
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// other configuration properties
});
return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}
Another way to load data is by using the setConfig() or parse() method inside React's useEffect():
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();
let columns = props.columns; // data for columns
let cards = props.cards; // data for cards
let rows = props.rows; // data for rows
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
});
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// other configuration properties
});
kanban.setConfig({ columns, cards, rows });
return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);
return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}
The setConfig() or parse() method can be handy for reloading data when changes are made.
At this point, the Kanban component is set up. When the component is added to the page, it initializes Kanban with the provided data. You can also adjust the configuration as needed. The Kanban API docs have the full list of available options.
Handling events
Kanban fires events whenever something happens-like a card is added or moved. These events can be used to trigger custom code. The complete list of events is available for reference.
To handle an event, update Kanban.jsx and add the following to the useEffect():
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});
kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
return () => {
kanban.destructor();
};
}, []);
// ...
Now, the app can be started, and Kanban will show up on the page with data loaded.
This is how DHTMLX Kanban can be integrated with React. The code can be tweaked as needed. For a more advanced example, take a look at the GitHub repository.

Skip to main content

Integration with Svelte

tip

It's helpful to know the basics of Svelte before jumping in here. If you want to brush up, check out the Svelte documentation.

DHTMLX Kanban works well with Svelte. There are some code samples showing how to use DHTMLX Kanban in a Svelte project. For more details, check out the Example on GitHub.

Creating a project

info

Before starting a new project, make sure you have Vite (optional) and Node.js installed.

There are a couple of ways to set up a Svelte project:

or

  • You can use Svelte with Vite (without SvelteKit):
npm create vite@latest

You can find more info in the related article.

Installation of dependencies

Let's call the project my-svelte-kanban-app and move into the app directory:

cd my-svelte-kanban-app

Install the dependencies and start the development server. You can use your preferred package manager:

  • For yarn, use these commands:
yarn
yarn start
  • For npm, use these commands:
npm install
npm run dev

The app should now be running locally (for example at http://localhost:3000).

Creating Kanban

Next, you'll need to get the DHTMLX Kanban source code. Stop the app for a moment and install the Kanban package.

Step 1. Package installation

Download the trial Kanban package and follow the README instructions. Just a heads up, the trial Kanban works for 30 days.

Step 2. Component creation

Now it's time to make a Svelte component to add Kanban with a Toolbar to the app. Create a new file in the src/ directory and call it Kanban.svelte.

Importing source files

Open up Kanban.svelte and import the Kanban source files. Here are a couple of things to keep in mind:

  • If you're using the PRO version and installed Kanban from a local folder, your import paths would look like this:
Kanban.svelte
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

Depending on the package, the CSS might be minified, so you might need to import kanban.min.css instead.

  • If you're using the trial version, use these paths:
Kanban.svelte
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
<script>

This tutorial shows how to set up the trial version of Kanban.

Setting containers and adding Kanban with Toolbar

To show Kanban with a Toolbar on the page, set up containers for both and initialize them using their constructors:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

let toolbar_container, kanban_container; // containers for Kanban and Toolbar
let kanban, toolbar;

onMount(() => {
// set up the Kanban component
kanban = new Kanban(kanban_container, {})

// set up the Toolbar component
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // give Toolbar access to Kanban's API
// other config options
})
});

onDestroy(() => {
kanban.destructor(); // clean up Kanban
toolbar.destructor(); // clean up Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Loading data

To get data into Kanban, you'll need to provide a data set. You can create a data.js file in the src/ directory and add some sample data:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/kanbans ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Then, in App.svelte, import the data and pass it as props to your <Kanban/> component:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { cards, columns, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Now, open Kanban.svelte and use the passed props in the Kanban configuration:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// other config options
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // give Toolbar access to Kanban's API
// other config options
})
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

If you want, you can also use the setConfig() or parse() method in Svelte's onMount() to load data into Kanban:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other config options
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // give Toolbar access to Kanban's API
// other config options
})

kanban.setConfig({ columns, cards, rows });
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Both setConfig() and parse(data) methods are handy for reloading data whenever something changes.

At this point, the Kanban component is good to go. Once it's on the page, it will initialize with your data. You can tweak the configuration as needed. To see all the available settings, check out the Kanban API docs.

Handling events

Whenever something happens in Kanban (like a user action), an event is triggered. You can use these events to run your own code. The full list of events is available.

In Kanban.svelte, update the onMount() method like this:

Kanban.svelte
<script>
// ...
let kanban;

onMount(() => {
kanban = new Kanban(kanban_container, {})

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});

onDestroy(() => {
kanban.destructor();
});
</script>

// ...

Step 3. Adding Kanban into the app

To bring the component into your app, open App.svelte and swap out the default code for this:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { columns, cards } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Now you can start the app and see Kanban loaded with your data.

Kanban with Svelte

This is the basic setup for integrating DHTMLX Kanban with Svelte. Feel free to customize things to fit your needs. For a more advanced example, check out the GitHub repo.

Integration with Vue
It's helpful to know the basics of Vue before diving into this guide. If you need a refresher, check out the Vue 3 documentation.
DHTMLX Kanban works smoothly with Vue. There are sample code snippets demonstrating how to use DHTMLX Kanban with Vue 3. For more details, see the Example on GitHub.
Creating a project
Make sure Node.js is installed before starting a new project.
To spin up a Vue project, just use:
npm create vue@latest
This command sets up and runs create-vue, which is the official Vue project starter. For more info, take a look at the Vue.js Quick Start.
In this example, the project is named my-vue-kanban-app.
Installation of dependencies
Move into your app’s folder:
cd my-vue-kanban-app
Install the dependencies and start up the development server. Depending on your package manager, use one of these:
- For yarn:
 
yarn
yarn start // or yarn dev
- For npm:
 
npm install
npm run dev
The app should now be running locally (for example, at http://localhost:3000).
Creating Kanban
Next, grab the DHTMLX Kanban source code. Stop the app for now, and install the Kanban package.
Step 1. Package installation
Download the trial Kanban package and follow the steps in the README. The trial version is available for 30 days.
Step 2. Component creation
Create a new Vue component to add Kanban with a Toolbar to your app. In the src/components/ directory, make a new file called Kanban.vue.
Import source files
Open Kanban.vue and import the Kanban source files. Keep in mind:
- If you’re using the PRO version and installed the Kanban package from a local folder, your imports will look like this:
 
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>
Depending on your package, the source files might be minified. In that case, make sure to import kanban.min.css instead.
- If you’re using the trial version, use these paths:
 
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>
This guide shows how to set up the trial version of Kanban.
Setting containers and adding Kanban with Toolbar
To show Kanban with a Toolbar, set up containers for both and initialize them with their constructors:
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export default {
    mounted() {
        // initialize the Kanban component
        this.kanban = new Kanban(this.$refs.kanban_container, {});
        // initialize the Toolbar component
        this.toolbar = new Toolbar(this.$refs.toolbar_container, {
            api: this.kanban.api, // provide Kanban inner API
            // other configuration properties
        });
    },
    unmounted() {
        this.kanban.destructor(); // destruct Kanban
        this.toolbar.destructor(); // destruct Toolbar
    }
};
</script>
<template>
    <div class="component_container">
        <div ref="toolbar_container"></div>
        <div ref="kanban_container" class="widget"></div>
    </div>
</template>
Adding styles
To make Kanban display properly, add these styles to your main CSS file:
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
    height: 100%;
    padding: 0;
    margin: 0;
}
/* specify styles for Kanban and Toolbar container */
.component_container {
    height: 100%; 
    margin: 0 auto;
}
/* specify styles for Kanban container */
.widget {
    height: calc(100% - 56px);
}
Loading data
To provide data for Kanban, create a data.js file in the src/ directory and add your data like this:
export function getData() {
    const columns = [
        {
            label: "Backlog",
            id: "backlog"
        },
        {
            label: "In progress",
            id: "inprogress"
        },
        // ...
    ];
    const cards = [
        {
            id: 1,
            label: "Integration with Angular/React",
            priority: 1,
            color: "#65D3B3",
            start_date: new Date("01/07/2021"),
            users: [3, 2],
            column: "backlog",
            type: "feature",
        },
        {
            label: "Archive the cards/kanbans ",
            priority: 3,
            color: "#58C3FE",
            users: [4],
            progress: 1,
            column: "backlog",
            type: "feature",
        },
        // ...
    ];
    const rows = [
        {
            label: "Feature",
            id: "feature",
        },
        {
            label: "Task",
            id: "task",
        }
    ];
    return { columns, cards, rows };
}
Now, open App.vue, import the data, and set it up using the data() method. Then pass it to the <Kanban/> component as props:
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";
export default {
    components: { Kanban },
    data() {
        const { columns, cards, rows } = getData();
        return { 
            columns, 
            cards,
            rows
        };
    }
};
</script>
<template>
    <Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>
Then, in Kanban.vue, use these props in the Kanban configuration object:
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export default {
    props: ["cards", "columns", "rows"],
    mounted() {
        this.kanban = new Kanban(this.$refs.kanban_container, {
            cards: this.cards,
            columns: this.columns,
            rows: this.rows,
            rowKey: "type",
            // other configuration properties
        });
        this.toolbar = new Toolbar(this.$refs.toolbar_container, {
            api: this.kanban.api, 
            // other configuration properties
        });
    },
    unmounted() {
        this.kanban.destructor(); 
        this.toolbar.destructor(); 
    }
};
</script>
<template>
    <div class="component_container">
        <div ref="toolbar_container"></div>
        <div ref="kanban_container" class="widget"></div>
    </div>
</template>
Alternatively, you can use the parse() method in the mounted() hook to load data into Kanban:
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";
export default {
    props: ["cards", "columns", "rows"],
    mounted() {
        this.kanban = new Kanban(this.$refs.kanban_container, {
            columns: [],
            cards: [],
            rows: [],
            rowKey: "type",
            // other configuration properties
        });
        this.toolbar = new Toolbar(this.$refs.toolbar_container, {
            api: this.kanban.api, 
            // other configuration properties
        });
        this.kanban.parse({ 
            cards: this.cards,
            columns: this.columns,
            rows: this.rows
        });
    },
    unmounted() {
        this.kanban.destructor(); 
        this.toolbar.destructor(); 
    }
};
</script>
<template>
    <div class="component_container">
        <div ref="toolbar_container"></div>
        <div ref="kanban_container" class="widget"></div>
    </div>
</template>
The parse(data) method lets you reload data whenever changes are made.
At this point, the Kanban component is set up and ready. Once you add it to the page, it initializes with your data. You can also pass in any extra configuration you need. To see all available properties, visit the Kanban API docs.
Handling events
When actions happen in Kanban, events are triggered. You can listen for these events and run your own code in response. Check out the full list of events.
In Kanban.vue, update the mounted() method like this:
<script>
// ...
export default {
    // ...
    mounted() {
        this.kanban = new Kanban(this.$refs.cont, {});
        this.kanban.api.on("add-card", (obj) => {
            console.log(obj.columnId);
        });
    },
    unmounted() {
        this.kanban.destructor();
    }
}
</script>
// ...
Now, go ahead and run the app to see the Kanban board loaded with your data.
This is the basic setup for integrating DHTMLX Kanban with Vue. The code can be tweaked as needed. For a more advanced example, check out the project on GitHub.

Integration with Angular
It's helpful to have a basic understanding of Angular before jumping in here. If you need a quick refresher, check out the Angular documentation.
DHTMLX Kanban works well with Angular. There are code samples available that show how to use DHTMLX Kanban in Angular projects. For more details, take a look at the Example on GitHub.
Creating a project
Make sure you have Angular CLI and Node.js installed before getting started.
To set up a new my-angular-kanban-app project, just use Angular CLI with this command:
ng new my-angular-kanban-app
If you want to follow along with this guide, remember to turn off Server-Side Rendering (SSR) and Static Site Generation (SSG/Prerendering) when setting up your Angular app!
This command will set up everything you need, so there’s no need to run any extra commands afterwards.
Installation of dependencies
Head into your new app’s directory:
cd my-angular-kanban-app
Next, install the dependencies and start up the dev server. The yarn package manager works well for this:
yarn
yarn start
Your app should now be running locally (for example, at http://localhost:3000).
Creating Kanban
To get started with DHTMLX Kanban, you’ll need the source code. First, stop your app and install the Kanban package.
Step 1. Package installation
Download the trial Kanban package and follow the instructions in the README file. Just a heads up: the trial version works for 30 days.
Step 2. Component creation
Next, set up an Angular component to include Kanban with a Toolbar in your app. Create a kanban folder inside src/app/, then add a new file called kanban.component.ts.
Import source files
Open up kanban.component.ts and import the Kanban source files. Here’s what to keep in mind:
- If you’re using the PRO version and installed Kanban from a local folder, your import will look like this:
import { Kanban, Toolbar } from 'dhx-kanban-package';
- If you’re using the trial version, the import should be:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
This guide shows how to work with the trial version.
Set containers and initialize the Kanban with Toolbar
To get Kanban and the Toolbar on your page, set up containers and initialize these components using their constructors:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // a template name used in the "app.component.ts" file as <kanban />
styleUrls: ["./kanban.component.css"], // include the css file
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
// initialize container for Toolbar
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// initialize container for Kanban
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
// initialize the Kanban component
this._kanban = new Kanban(this.kanban_container.nativeElement, {});
// initialize the Toolbar component
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// other configuration properties
});
}
ngOnDestroy(): void {
this._kanban.destructor(); // destruct Kanban
this._toolbar.destructor(); // destruct Toolbar
}
}
Adding styles
To make sure Kanban displays properly, add the right styles. You can create a kanban.component.css file in src/app/kanban/ and include these styles for Kanban and its container:
/* import Kanban styles */
@import "@dhx/trial-kanban/dist/kanban.css";
/* specify styles for initial page */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}
/* specify styles for Kanban and Toolbar container*/
.component_container {
height: 100%;
margin: 0 auto;
}
/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}
Loading data
To fill Kanban with data, you’ll need a data set. Create a data.ts file in src/app/kanban/ and add some sample data like this:
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];
const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];
const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];
return { columns, cards, rows };
}
Now, open kanban.component.ts. Import your data file and add the data properties to the Kanban configuration object inside ngOnInit() like this:
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // import data
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
const { cards, columns, rows } = getData(); // initialize data properties
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // apply column data
cards, // apply card data
rows, // apply row data
rowKey: "type",
// other configuration properties
});
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// other configuration properties
});
}
ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}
You can also load data into Kanban using the setConfig() or parse() method inside the ngOnInit() method.
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // import data
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';
@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})
export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;
private _kanban!: Kanban;
private _toolbar!: Toolbar;
ngOnInit() {
const { cards, columns, rows } = getData(); // initialize data properties
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// other configuration properties
});
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// other configuration properties
});
// apply the data via the parse() method
this._kanban.setConfig({
columns,
cards,
rows
});
}
ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}
The setConfig or parse() method lets you reload data whenever you need to update it.
At this point, the Kanban component is good to go. When you add the element to a page, Kanban will initialize with your data. You can also tweak the configuration as needed. For all available options, check out the Kanban API docs.
Handling events
Whenever someone interacts with Kanban, events get fired. You can use these events to react and run your own code. The full list of events is available in the docs.
To handle events, open kanban.component.ts and add the following to ngOnInit():
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});
this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}
ngOnDestroy(): void {
this._kanban.destructor();
}
Step 3. Adding Kanban into the app
To use the KanbanComponent in your app, open src/app/app.component.ts and replace the default code with this:
import { Component } from "@angular/core";
@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}
Next, create app.module.ts in src/app/ and add KanbanComponent as shown here:
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";
@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}
Finally, open src/main.ts and update it like this:
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));
Now you can start the app and see Kanban loaded with your data.
That’s it for integrating DHTMLX Kanban with Angular. Feel free to adjust the code to fit your project’s needs. There’s a more advanced example available on GitHub.